<?php
/*--------------------------------------------------------------------
 OnCreateModifierIdCollectionEventListener.php 2020-2-18
 Gambio GmbH
 http://www.gambio.de
 Copyright (c) 2020 Gambio GmbH
 Released under the GNU General Public License (Version 2)
 [http://www.gnu.org/licenses/gpl-2.0.html]
 -------------------------------------------------------------------*/

declare(strict_types=1);

namespace Gambio\Shop\Properties\ProductModifiers\Database\Listeners;

use Gambio\Shop\ProductModifiers\Modifiers\Collections\ModifierIdentifierCollection;
use Gambio\Shop\ProductModifiers\Modifiers\Events\OnCreateModifierIdCollectionEvent;

/**
 * Class OnCreateModifierIdCollectionEventListener
 * @package Gambio\Shop\Properties\ProductModifiers\Database\Listeners
 */
class OnCreateModifierIdCollectionEventListener
{
    /**
     * @param OnCreateModifierIdCollectionEvent $event
     */
    public function __invoke(OnCreateModifierIdCollectionEvent $event)
    {
        $result = new ModifierIdentifierCollection;
        
        $event->setModifierIdentifierCollection($result);
    }
}